//////////////////////////////////////////////////////////////////////
// Game  : 15
// Autor : Dmitry Nikolaev (Russia)
// mailto: k175@nm.ru
// Lang  : Delphi 6
program fifteen;
{$R fifteen.res} {$R menu.res}  {$R about.res} {$R scores.res} {$R new.res}
uses
  Windows, Messages;
Type
 ResStruct = record
                name:string;
                count:DWORD;
               end;
 ResStructArr = array[0..11] of ResStruct;
var
 Counter        : integer;
 WndMain        : HWND;
 MyMainMenu     : HMENU;
 Mesg           : Tmsg;
 wc             : TWndClass;
 BitMaps        : Array[0..16] of HBitMap;
 mas            : Array[0..5,0..5] of integer;
 i,j,m,cxBorder,cyBorder,cyCaption,cxScreen,cyScreen,cyMenu,Mode :Integer;
 temp           : ResStructArr;
{==============================================================================}
Function MyIntToStr(a:integer):string; //     SysUtils  
var
 c,d,i,count:integer;
 m,n:array[1..10] of integer;
 s:string;
begin
 c:=1;
 i:=1;
 repeat
  count:=i;
  c:=c*10;
  i:=i+1;
 until abs(a div c)<=0;
 c:=1;
 d:=10;
 for i:= 1 to count do
  begin
    m[i]:=a mod d div c;
    c:=c*10;
    d:=d*10;
  end;
 s:='';
 for i:=1 to count do              // invert
  begin
   n[i]:=m[count-i+1];
   if (i=1) and (n[1]<0) then s:=s+'-';
   s:=s+Char(abs(n[i])+48);
 end;
 result:=s;
end;

{==============================================================================}
Procedure SaveREZ(REZ:ResStructArr);  // /  
label Bye;
var
 key1:HKEY;
 p:PCHAR;
 i:integer;
 s:string;
 vol:DWORD;
 err:bool;
begin
 err:=false;
 if RegOpenKeyEx(HKEY_LOCAL_MACHINE,'Software',0,KEY_ALL_ACCESS,key1)<>error_success then
   begin
    err:=true;
    goto bye;
   end
 else
 //  
 RegCreateKeyEx(
                key1,
                'TurtleSoft',
                0,
                nil,
                REG_OPTION_NON_VOLATILE,
                KEY_ALL_ACCESS,
                nil,
                key1,
                0
                );

 if RegOpenKeyEx(HKEY_LOCAL_MACHINE,'Software\TurtleSoft',0,KEY_ALL_ACCESS,key1)<>error_success then
   begin
    err:=true;
    goto bye;
   end
 else
 for i:= 1 to 10 do
   begin
    s:=rez[i].name;
    p:=PCHAR(s);
    RegSetValueEx(key1,PCHAR('name'+Myinttostr(i)),0,REG_SZ,p,Length(p)+1);
    vol:=REZ[i].count;
    RegSetValueEx(key1,PCHAR('count'+Myinttostr(i)),0,REG_DWORD,@vol,sizeof(vol));
   end;
 Regclosekey(key1);
 bye:
 if err then
   begin
     MessageBox(WndMain,'SaveList Error','Save ERROR',mb_iconerror or mb_ok);
     halt;
  end;
end;
{==============================================================================}
Function ReadRez:ResStructArr;
label bye;
var
 key1     : HKEY;
 data     : array[0..255] of Char;
 DataLen  : DWORD;
 DataValue: DWORD ABSOLUTE data;
 ValueType: DWORD;
 ERR      : bool;
 temp     : ResStructArr;
 i        : integer;
 vol      : DWORD;
begin
Err:=false;
//  -
if RegOpenKeyEx(HKEY_LOCAL_MACHINE,'Software\TurtleSoft',0,KEY_QUERY_VALUE,key1)<>error_success then
// 
 begin
   err:=true;
   goto bye;
 end
// - 
else
for i:= 1 to 10 do
 begin
  DataLen:=SizeOf(data);
  //    
  if RegQueryValueEx(key1,PCHAR('name'+MyIntToStr(i)),nil,@ValueType,@dataValue,@DataLen) = ERROR_SUCCESS then
     temp[i].name:=String(Pchar(@data))
  else
     begin
       err:=true;
       goto bye;
     end;
  //    
    DataLen:=SizeOf(data);
    if RegQueryValueEx(key1,PCHAR('count'+MyIntToStr(i)),nil,@ValueType,@dataValue,@DataLen) = ERROR_SUCCESS then
    temp[i].count:=dataValue
    else
     begin
       err:=true;
       goto bye;
     end;
 end; //end i
   readRez:=temp;
   Regclosekey(key1);
   bye:
     //  ..  
     if err=true then
       begin
        MessageBox(WndMain,'Can not open "High Scores.." table','ERROR',mb_ok or mb_iconError);
        for i:=1 to 10 do
         begin
          temp[i].name:='...';
          temp[i].count:=1000-i*70-200;
         end;
       saveRez(temp);
       end;

   readRez:=temp;
end;
{==============================================================================}

function YouWin:boolean;
var
i,j,rez,count:integer;
begin
 rez:=0;
 count:=0;
 for i:= 1 to 4 do
  for j:= 1 to 4 do
    begin
      count:=count+1;
     if mas[i,j]<>count then rez:=rez+1;
    end;
if rez=0 then YouWin:=true else YouWin:=false;
end;
{==============================================================================}
procedure unsort(iter:integer);
var
 i,j,t1,t2,c1,c2,c:integer;
begin
randomize;
c1:=0;
for i:= 1 to 4 do
 for j:= 1 to 4 do
  begin
   c1:=c1+1;
   mas[i,j]:=c1;
  end;
for i:= 1 to iter do
  begin
    t1:=random(4)+1;
    t2:=random(4)+1;
    c1:=random(4)+1;
    c2:=random(4)+1;
    c:=mas[t1,t2];
    mas[t1,t2]:=mas[c1,c2];
    mas[c1,c2]:=c;
  end;
end;
{==============================================================================}
function InputNameDialogProc(wnd : THandle; msg : DWORD; wParam, lParam : DWORD) : Bool; stdcall;
var
 p:PChar;
 i,j:integer;
 edit1:HWND;
 REZ:ResStructArr;
 t:ResStruct;
 l:integer;
begin
  case msg of
   WM_INITDIALOG:
    begin

    end;
   WM_COMMAND :
    Begin
      case loWord(wParam) of
      IDOK :               //      ;
        Begin
         rez:=readrez;
          REZ[11].count:=counter;
          edit1:=GetDlgItem(Wnd,143);
          l:=SendMessage(edit1,em_linelength,0,0);
          GetMem(p,l+1);
          Windows.GetDlgItemText(wnd,143,p,l+1);
          REZ[11].name:=String(p);
          freemem(p,l+1);

          for i:= 1 to 10 do
           for j:= 1 to 10 do
             begin
               if rez[j].count<rez[j+1].count then
                 begin
                   t:=rez[j];
                   rez[j]:=rez[j+1];
                   rez[j+1]:=t;
                 end;
             end;
          SaveREZ (rez);
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
        End;
      174:  // cancel
        Begin
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
        End;
      end; //case
    End;
   end;
Result:=false;
end;
{==============================================================================}
function ScoresDialogProc(wnd : THandle; msg : DWORD; wParam, lParam : DWORD) : Bool; stdcall;
var
 i:integer;
 st:string;
 memo:HWND;
 rez: ResStructArr;
begin
  case msg of
   WM_INITDIALOG:
      begin
          memo:=windows.GetDlgItem(wnd,101);
          rez:=ReadRez;
          st:='BEST GAMERS:'#13#10'============';
          for i:= 1 to 10 do st:=st+#13#10+'['+MYINTTOSTR(rez[i].count)+']  '+rez[i].name;
          SetWindowText(Memo,PCHAR(st));
        end;
   WM_COMMAND :
    Begin
      case loWord(wParam) of
      IDOK :
        Begin
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
        End;
      610  :
         begin
         for i:=1 to 10 do
           begin
             temp[i].name:='...';
             temp[i].count:=1000-i*70-200;
            end;
          SaveRez(temp);
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
         end;
      end; //case
    End;
   end;
Result:=false;
end;
{==============================================================================}
function AboutDialogProc(wnd : THandle; msg : DWORD; wParam, lParam : DWORD) : Bool; stdcall;
var
 temp:HWND;
 memo:HWND;
 dc:HDC;
 ps:PAINTSTRUCT;
Begin
case msg of
 WM_INITDIALOG:
  Begin
    Memo:=windows.GetDlgItem(Wnd,401);    //   ID  HWND
    dc:=GetWindowDC(Memo);
    SetWindowText(memo,'Program: "15" v 1.0b   FREEWARE"'#13#10'Autor: Nikolaev Dmitry (Turtle)'#13#10'mailto: k175@nm.ru'#13#10#13#10'Welcome to:'#13#10'IRC: irc.rusnet.ru'#13#10'#Delphi');
    DrawIcon(DC,0,0,LoadIcon(hInstance,MAKEINTRESOURCE (800)));
    ReleaseDC(Memo,DC);
    updateWindow (Memo);
  end;
 WM_COMMAND :
  Begin
    case loWord(wParam) of
      IDOK :
        Begin
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
        End;
    end;
  End;
end;
Result:=false;
End;
{==============================================================================}

{==============================================================================}
function WindowProc(Wnd:HWND;Msg:integer;wParam:WPARAM;lParam:LPARAM):LRESULT; stdcall;
label
 jump;
var
 dc      : HDC;
 dcMem   : Hdc;
 ps      : PAINTSTRUCT;
 i,j,c,xMouse,yMouse,xpos,ypos : integer;
 rect1   : PRECT;

begin
 case Msg of
  WM_DESTROY:
   begin
     PostQuitMessage(0);
     exit;
     result:=0;
   end;
  WM_PAINT:
    begin
     dc:=BeginPaint(Wnd,ps);
     DcMem:=CreateCompatibleDc(dc);

     Case Mode of
     0: begin
          SelectObject(dcMem,LoadBitmap(hInstance,'#920'));
          BitBlt(dc,0,15,128,110,dcMem,0,0,SRCCOPY);
        end;

     1:
     begin
      for i:= 1 to 4 do
       begin
        for j:= 1 to 4 do
         begin
          SelectObject(dcMem,bitmaps[mas[i,j]]);
          BitBlt(dc,(j-1)*32,(i-1)*32,32,32,dcMem,0,0,SRCCOPY);
         end;
       end;
      GetStockObject(system_fixed_font);

      TextOut(dc,3,128,PChar('                                      '),44);
      TextOut(dc,0,128,PCHAR('Points: '+MYIntToStr(counter)),8+Length(MyIntToStr(counter)));
      end;
      2:
        begin
          SelectObject(dcMem,LoadBitmap(hInstance,'#921'));
          BitBlt(dc,0,0,128,128,dcMem,0,0,SRCCOPY);
        end;
     end; //case
     DeleteDC(dcMem);
     EndPaint(wnd,ps);
   end;
   WM_LBUTTONDOWN:
    begin
      xMouse:=HIWORD(lParam);
      yMouse:=LoWord(lParam);
      xPos:=xMouse div 32 +1;
      yPos:=yMouse div 32 +1;
      if mas[xPos,yPos]=16 then goto jump;
      if (xMouse>127) or (yMouse>127) or (xMouse<0) or (yMouse<0) then goto jump;
      if (mas[xPos-1,yPos]=16) then begin mas[xPos-1,yPos]:=mas[xPos,yPos]; mas[xPos,yPos]:=16;counter:=counter-1; end;
      if (mas[xPos+1,yPos]=16) then begin mas[xPos+1,yPos]:=mas[xPos,yPos]; mas[xPos,yPos]:=16;counter:=counter-1; end;
      if (mas[xPos,yPos+1]=16) then begin mas[xPos,yPos+1]:=mas[xPos,yPos]; mas[xPos,yPos]:=16;counter:=counter-1; end;
      if (mas[xPos,yPos-1]=16) then begin mas[xPos,yPos-1]:=mas[xPos,yPos]; mas[xPos,yPos]:=16; counter:=counter-1;end;
      if counter=-1 then counter:=0;
      InvalidateRect (Wnd, Nil, FALSE) ;
      if YouWin then
        begin
          mode:=2;
          InvalidateRect (Wnd, Nil, FALSE) ;
          DialogBox(hInstance,'#504',wnd,@InputNameDialogProc);
          DialogBox(hInstance,'#502',wnd,@ScoresDialogProc);
        end;
      result:=0;
      jump:
    end;
   WM_COMMAND:
    begin
     if lParam=0 then // 
      begin
        case LoWord(wParam) of  //id menu item
           202: SendMessage(Wnd,WM_DESTROY,0,0);
           201: begin
                 unsort(100); // 100 -  
                 mode:=1;
                 counter:=1000;
                 InvalidateRect (Wnd, Nil, FALSE) ;
                end;
           203: DialogBox(hInstance,'#501',WndMain,@AboutDialogProc);
           204: DialogBox(hInstance,'#502',Wnd,@ScoresDialogProc);
           205: begin  // rewrite List
                  for i:=1 to 10 do
                    begin
                     temp[i].name:='...';
                     temp[i].count:=1000-i*70-200;
                    end;
                  SaveRez(temp);
                  DialogBox(hInstance,'#502',Wnd,@ScoresDialogProc);
                end;
        end; {end case}
      end;
    end;
   else result:=DefWindowProc(Wnd,Msg,wParam,lParam);
 end;
end;
{==============================================================================}
begin
counter:=1000;
mode:=0;
// ===============

 wc.lpfnWndProc:=@WindowProc;
 wc.cbClsExtra:=0;
 wc.cbWndExtra:=0;
 wc.hInstance:=hInstance;
 wc.hCursor:=LoadCursor(hInstance,IDC_ARROW);
 wc.hIcon:=LoadIcon(hInstance,'#800');
 wc.hbrBackground:=GetStockObject(BLACK_BRUSH);
 wc.lpszMenuName:=nil;
 wc.lpszClassName:='WndMainClass';

 RegisterClass(wc);
 cxBorder:=GetSystemMetrics(SM_CXDLGFRAME);
 cyBorder:=GetSystemMetrics(SM_CYDLGFRAME);
 cyCaption:=GetSystemMetrics(SM_CYCAPTION);
 cxScreen:=GetSystemMetrics(SM_CXSCREEN);
 cyScreen:=GetSystemMetrics(SM_CYSCREEN);
 cyMenu:=GetSystemMetrics(SM_CYMENU);
 WndMain:=CreateWindow( 'WndMainClass',
                         '15',
                         WS_CAPTION OR WS_SYSMENU OR WS_MINIMIZEBOX,
                         cxScreen div 2 - 64,    //    
                         cyScreen div 2 - 64,
                         128+2*cxBorder,
                         128+2*cyBorder+cyCaption+cyMenu+16,
                         0,
                         0,
                         hInstance,
                         nil);

 for i:=1 to 16 do
 bitmaps[i]:=LoadBitmap(hInstance,MakeIntResource(900+i));

 MyMainMenu:=LoadMenu(hInstance,'#200');
 SetMenu(WndMain,MyMainMenu);
 ShowWindow(WndMain,CmdShow);
 UpdateWindow (WndMain);
 While GetMessage (Mesg,0,0,0) do
  begin
    TranslateMessage (Mesg);
    DisPatchMessage (Mesg);
  end;
end.
